/* Agent actuate Library

    ΏۃfoCXF
    EATtiny44A/84A
    
    gpF
    E8MHzNbNi0.125usjvXP[Ȃ
    
    F
    lF
    
*/

#ifndef ACTUATE_H
#define ACTUATE_H

// ^p^
#define TURNON_ALL          0xFF                                                // So
#define TURNOFF_ALL         0x00                                                // SNA
#define TURNON_OUTSIDE      0b00010101                                          // LEDOOp
#define TURNON_INSIDE       0b00101010                                          // LEDOp
#define TURNON_UPANGLE      0b00100011                                          // LEDOp
#define TURNON_LANGLE       0b00111000                                          // LEDOp
#define TURNON_RANGLE       0b00001110                                          // LEDEOp

// ACT|[gp}XNp^
#if defined (__AVR_ATtiny44A__) || defined (__AVR_ATtiny84A__)
    #define ACT_INIT_PA_BUT_TWI 0b11010000                                      // ACTo̓|[giI2Cs܂܂j
    #define ACT_INIT_PA_TWI     0b10000000                                      // ACTo̓|[giI2Cs܂ށj
    
    #define ACT8_PORTA_MASK     0b01111111                                      // PA6..0
    #define ACT8_PORTB_MASK     0b00000001                                      // PB0
    
    #define ACT6_PORTA_MASK     0b00101111                                      // PA5/3..0
    #define ACT6_PORTB_MASK     0b00000001                                      // PB0
    
    #define ACT4_PORTA_FIX      0b00101010                                      // PA5/3/1   =͐ݒ(vAbvłgxɌŒ)
    #define ACT4_PORTA_MASK     0b01010101                                      // PA6/4/2/0 =o͐ݒ(ftHgnC)
    #define ACT4_PORTB_MASK     0b00000001                                      // PB0       =o͐ݒ(ftHg[)
    // sgpACT|[g PB0 =o͐ݒ(ftHg[)܂ܕ␳p
    
    #define ACT2_PORTA_FIX      0b00001010                                      // PA3/1     =͐ݒ(vAbvłgxɌŒ)
    #define ACT2_PORTA_MASK     0b00000101                                      // PA2/0     =o͐ݒ(ftHgnC)
    #define ACT2_PORTB_MASK     0b00000001                                      // PB0       =o͐ݒ(ftHg[)
    // sgpACT|[g PA6..4/PB0 =o͐ݒ(ftHg[)܂ܕ␳p
    
#elif defined (__AVR_ATtiny2313__) || defined (__AVR_ATtiny4313__)
    #define ACT_INIT_PB         0b10100001
#elif defined (__AVR_ATmega88P__) || defined(__AVR_ATmega88PA__)
    #define ACT_INIT_PB         0b11000001
#endif

#define ACT_MASK_BIT4321        0b00011110
#define ACT_MASK_BIT43210       0b00011111
#define ACT_MASK_BIT7           0b10000000
#define ACT_MASK_BIT6           0b01000000
#define ACT_MASK_BIT5           0b00100000
#define ACT_MASK_BIT4           0b00010000
#define ACT_MASK_BIT3           0b00001000
#define ACT_MASK_BIT2           0b00000100
#define ACT_MASK_BIT1           0b00000010
#define ACT_MASK_BIT0           0b00000001

// ACTo͎
enum ACT_KIND {
    ACT0    =0                                                                  // óGlGH\𖢐ݒ̂܂ܕspӂȏo͂h~邽
,   ACT2    =2                                                                  // ~j Qbito
,   ACT4    =4                                                                  // ~j Sbito
,   ACT6    =6                                                                  // W Ubito
,   ACT8    =8                                                                  // t Wbito
};

// vg^Cv錾

// ACTp^ϊ
//yzACTp^(ϊO)
//yߒlzACTp^(ϊ)
uint8_t convact(uint8_t);

// ACTo
//yzACTp^(8bit)
//yߒlzȂ
void actuate(uint8_t);

#endif
