/* Agent Library Common

    ΏۃfoCXF
    EATtiny44A/84A
    
    gpF
    E8MHzNbNi0.125usjvXP[Ȃ
    
    F
    lF

*/

#include <avr/io.h>
#include <avr/interrupt.h>

#include "agent_lib.h"
#include "actuate.h"

volatile uint8_t act_series[]={                                                 // ACTp^̔z
    0b00101010
   ,0b00000000
   ,0b00110110
   ,0b00000000
   ,0b00010101
   ,0b00000000
};
volatile uint8_t act_id=0;                                                      // ACTp^̃CfbNX
volatile uint8_t rhythm_source =DEFAULT_RHYTHM_SOURCE;                          // Y\[X

// xNgFXCb`iPB1/PCINT9j
ISR (PCINT1_vect) {
    
    if (BIT_CHECK(PCINT9_PIN, PCINT9_BIT)) {
        return;                                                                 // PCINT9 ͖
    }
    
    switch (rhythm_source) {
    case SWITCH_TRG:
        proceed_act();                                                          // ACTo͂ACTؑ
        break;
    case TIMER_TRG:
        // WDTG~ȂnCғȂ~
        if (WDTCSR == 0x00) {
            RESET_WDT;                                                          // WDT Zbg    wdt_reset();
            WDTCSR |= _WDT_CHANGE;                                              // WDT ݒύXiFύXO̕K{j
            WDTCSR = _WDT_INTERRUPT | _WDT_500MS;                               // WDT MODE , PRESCALER
        }
        else {
            RESET_WDT;                                                          // WDT Zbg    wdt_reset();
            WDTCSR |= _WDT_CHANGE;                                              // WDT ݒύXiFύXO̕K{j
            WDTCSR = 0x00;                                                      // WDT ~
        }
        break;
    }

}

// xNgFWatch Dog Timer
ISR (WATCHDOG_vect) {
    proceed_act();                                                              // ACTo͂ACTؑ
}

// ACTo͂ACTؑ
void proceed_act(void) {
    actuate(act_series[act_id]);                                                // ACTo
    if (++act_id >= sizeof(act_series)) act_id = 0;                             // zؑ
}
